# -*- coding: utf-8 -*-
"""
CREATED
   @author: Morten Lybech Thøgersen at 2021-05-19

DESCRIPTION:
   API test of the netcdf download.

USAGE:
   N/A

NOTES:
   N/A

REFERENCES
   N/A
"""


import emdapiglobalatlasservice
import pandas as pd
import matplotlib.pyplot as plt
import tilemapbase
import random
from tabulate import tabulate
from shapely.geometry import Point
from io import RawIOBase
import time
import numpy as np
from scipy.special import gamma
import requests
import warnings
import shutil
import xarray as xr
import os
warnings.filterwarnings('ignore')


if __name__ == "__main__":

    # Login to databases
    login_token = '7c279924-6458-4e19-874a-9c6545079437'
    config_atlas = emdapiglobalatlasservice.Configuration()
    config_atlas.host = "http://betaapi.emd.dk/global-atlas-service"
    #config_atlas.host = "http://127.0.0.1:8080/global-atlas-service"
    config_atlas.api_key['X-Auth'] = login_token
    emdapi_atlas = emdapiglobalatlasservice.GlobalAtlasServicesApi(emdapiglobalatlasservice.ApiClient(config_atlas))

    # Get data from API
    dataset_id = '99227443-8cb6-44c0-8d6c-a10fb3696f50'  # EMD-GASP dataset for Sweden
    longitude = 14.5
    latitude = 64.0

    filename = "c:/temp/test2.nc"
    if not(os.path.exists(filename)):
        with emdapi_atlas.atlasdata_controller_get_atlasdownload_area(dataset_id, "resource-sector", latitude, longitude, 10, 10, data_type="netcdf", _preload_content=False) as file_object:
            with open(filename, 'wb') as out_file:
                shutil.copyfileobj(file_object, out_file)
            file_object.release_conn()

    swedish_ar = xr.open_dataset(filename)
    df_swedish = swedish_ar.to_dataframe()
    df_swedish.to_csv("c:/temp/test.csv")

